/*
CAudioscrobbler MFC thingy
Copyright  2005 James Chapman
http://www.vuplayer.com

version 0.1 (1 Mar 2005)
- initial version, using v1.1 of the Audioscrobbler protocol
- not suitable for unicode builds

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AUDIOSCROBBLER_H__5C0B3845_944D_4BCD_8FDB_8822F23F5A87__INCLUDED_)
#define AFX_AUDIOSCROBBLER_H__5C0B3845_944D_4BCD_8FDB_8822F23F5A87__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// You should use your own client variables here (use ID="tst", VERSION="0.1" for testing purposes)
const CString SCROBBLER_CLIENT="MFCscrobbler";
const CString SCROBBLER_ID="tst";
const CString SCROBBLER_VERSION="0.1";
const CString SCROBBLER_UPDATEURL="http://www.audioscrobbler.com/";

const CString SCROBBLER_HANDSHAKE="http://post.audioscrobbler.com/?hs=true&p=1.1";
const CString SCROBBLER_CONTENTTYPE="Content-Type: application/x-www-form-urlencoded\r\n";

const int SCROBBLER_MAXWAIT=60;

class CAudioscrobbler  
{
public:
	CAudioscrobbler();
	virtual ~CAudioscrobbler();
	HANDLE m_hThreadFinished;
	HANDLE m_hThreadWait;
	HANDLE m_hSubmitWait;

	// Call this first (pretty obvious).
	// Username should be UTF-8 encoded, md5pass should be the MD5 value of the user's password.
	// You don't have to use a cache or log file, but it's recommended.
	// Set showupdate to zero to prevent any UPDATE URL from being shown.
	BOOL Init(CString username,CString md5pass,CString cachefile="",CString logfile="",BOOL showupdate=1);

	// Call this each time you wish to submit a track; all strings should be UTF-8 encoded.
	BOOL AddTrack(CString artist,CString track,CString album,CString mbid,long length,time_t start);

	// Call this to cleanup.
	void Finish();

	// Utility functions.
	void STRtoMD5(CString& str);	// Converts a CString to an MD5 value
	void STRtoURL(CString& str);	// Converts a CString to a URL encoded value
	void ViewLog();					// Displays the current log file
	void ClearLog();				// Clears the current log file
	BOOL UpdateShown()				// Returns 1 if the UPDATE URL has been shown
	{ return m_bUpdateShown;}

	// These functions are used internally; you don't need to call them.
	int DoHandshake();				// Return value: >0=OK, 0=FAIL but try again, -1=ABORT
	int DoSubmit();					// Return value: >0=OK, 0=FAIL but try again, -1=ABORT
	void ShowUpdate();				// Displays the UPDATE URL

private:
	BOOL m_bShowUpdate;
	BOOL m_bUpdateShown;
	CString m_CacheFile;
	CString m_LogFile;
	CString m_Username;
	CString m_Password;
	CString m_Challenge;
	CString m_SubmitURL;
	CList<CString,CString&> m_SubmitList;

	void ReadCache();
	void WriteCache();
	void WriteLogEntry(CString line);
};

#endif // !defined(AFX_AUDIOSCROBBLER_H__5C0B3845_944D_4BCD_8FDB_8822F23F5A87__INCLUDED_)
